/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;

import javax.validation.Valid;

import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.community.vo.ResidentialVO;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.constant.BladeConstant;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.estate.dto.AccessRecordCountDto;
import org.springblade.estate.dto.AccessRecordDTO;
import org.springblade.estate.entity.AccessRecord;
import org.springblade.estate.vo.AccessRecordVO;
import org.springblade.system.expand.feign.IConfClient;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springblade.system.user.entity.User;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.estate.wrapper.AccessRecordWrapper;
import org.springblade.estate.service.IAccessRecordService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.Map;

/**
 * 控制器
 *
 * @author BladeX
 * @since 2021-03-30
 */
@RestController
@AllArgsConstructor
@RequestMapping("/accessrecord")
@Api(value = "出入记录接口", tags = "出入记录接口")
public class AccessRecordController extends BladeController {

	private final IAccessRecordService accessRecordService;
	private final IOrgPositionClient orgPositionClient;
	private final IResidentialClient residentialClient;
	private final IConfClient confClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入accessRecord")
	public R<AccessRecordVO> detail(AccessRecord accessRecord) {
		AccessRecord detail = accessRecordService.getOne(Condition.getQueryWrapper(accessRecord));
		return R.data(AccessRecordWrapper.build(confClient).entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入accessRecord")
	public R<IPage<AccessRecordVO>> list(AccessRecordDTO accessRecord, Query query, BladeUser bladeUser) {
		QueryWrapper<AccessRecord> queryWrapper = Condition.getQueryWrapper(accessRecord);
		queryWrapper.lambda().orderByDesc(AccessRecord::getCreateTime);
		if(StringUtil.isNotBlank(accessRecord.getQueryDate())){
			queryWrapper.lambda().like(AccessRecord::getOpenTime, accessRecord.getQueryDate());
		}
		IPage<AccessRecord> pages = accessRecordService.page(Condition.getPage(query), (!bladeUser.getTenantId().equals(BladeConstant.ADMIN_TENANT_ID)) ? queryWrapper.lambda().eq(AccessRecord::getTenantId, bladeUser.getTenantId()) : queryWrapper);
		return R.data(AccessRecordWrapper.build(confClient).pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入accessRecord")
	public R<IPage<AccessRecordVO>> page(AccessRecordVO accessRecord, Query query) {
		IPage<AccessRecordVO> pages = accessRecordService.selectAccessRecordPage(Condition.getPage(query), accessRecord);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入accessRecord")
	public R save(@Valid @RequestBody AccessRecord accessRecord) {
		return R.status(accessRecordService.save(accessRecord));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入accessRecord")
	public R update(@Valid @RequestBody AccessRecord accessRecord) {
		return R.status(accessRecordService.updateById(accessRecord));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入accessRecord")
	public R submit(@Valid @RequestBody AccessRecord accessRecord) {
		return R.status(accessRecordService.saveOrUpdate(accessRecord));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(accessRecordService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 出入记录初始化，关联新的小区和图片去除前缀
	 */
	@PostMapping("/initData")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R initData() {
		long beginTime = System.currentTimeMillis();
		List<AccessRecord> accessRecords = this.accessRecordService.getBaseMapper().selectList(new QueryWrapper<>(new AccessRecord()));
		accessRecords.forEach(accessRecord -> {
			if (accessRecord.getFaceUrl() != null){
				accessRecord.setFaceUrl(accessRecord.getFaceUrl().replace("http://139.9.103.171:1888/miniofile/", ""));
			}
			Residential searchResidential = new Residential();
			searchResidential.setGridId(accessRecord.getResidentialId());
			if ("000000".equals(accessRecord.getTenantId())) {
				ResidentialVO detail = residentialClient.detail(searchResidential);
				if (detail != null) {
					accessRecord.setResidentialId(detail.getId());
					accessRecord.setAgencyId(detail.getAgencyId());
					accessRecord.setAgencyName(detail.getAgencyName());
					accessRecord.setResidentialName(detail.getName());
				}
			}
			accessRecordService.updateById(accessRecord);

		});
		long endTime = System.currentTimeMillis();
		return R.data("耗时：" + (endTime - beginTime) / 1000 + "秒");
	}

	/**
	 * 出入记录数据统计
	 */
	@GetMapping("/getAccessCount")
	@ApiOperationSupport(order = 8)
	@ApiOperation(value = "数据统计",notes = "统计")
	public AccessRecordCountDto getAccessCount(){
		AccessRecordCountDto accessRecordCountDto = new AccessRecordCountDto();
		accessRecordCountDto.setDayCount(accessRecordService.selectDayAccessRecordCount());
		accessRecordCountDto.setWeekCount(accessRecordService.selectWeekAccessRecordCount());
		accessRecordCountDto.setMonthCount(accessRecordService.selectMonthAccessRecordCount());
		accessRecordCountDto.setYearCount(accessRecordService.selectYearAccessRecordCount());
		return accessRecordCountDto;
	}

}
